#include "allegro.h"
#include "levels.h"

//add pushable objects
//don't allow people to hang out of portals
//game ending
//max momentum, make so that there will be traps at the location where you would expect someone's momentum to run out &c.
//add pause after finishing level

void init();
void deinit();

int min(int a, int b)
{
	if (a<b) return a;
	else return b;    
}

int max(int a,int b)
{
	if (a>b)  return a;
	else return b;
}
const int pan = 128;
const int pitch = 1000;

int mode = 1; 
/* 0 2d, 
	1 squish bottom to top, 
	2 squish top to bottom 
	3 squish left to right 
	4 squish right to left
 */

SAMPLE *sound[3];
const int S_FINISH=0;
const int S_SHOOT=1;
const int S_FAIL=2;

int colorkey[7];

int curlevel;
int px;
int py;  
int pm;
int pmdir;

int canpress;
const int presstimer=3;

const int tilesize=30;
int display[levelsize][levelsize];

BITMAP *buffer;


/* FRAMERATE CONTROL*/

void initlevel()
{
	/*     //draw background
     clear_to_color(bg,makecol(50,50,50));       
     
     //find where exit is; maybe encode starting point in similar manner? (and boulder things?)
	 
	 
     if (curlevel<levelcount-1)
     {
	 int ex;
	 int ey;
	 for (int i=0;i<levelsize;i++)
	 for (int j=0;j<levelsize;j++)
	 if (level[curlevel][j][i]==8)
	 {
	 ex=i;
	 ey=j;
	 }                       
	 
	 for (int i=0;i<levelsize;i++)
	 for (int j=0;j<levelsize;j++)
	 if (level[curlevel+1][j][i]>0)
	 {
	 int x = (leveloffset-displayoffsetx)*tilesize+ex*tilesize+1-startingpoint[curlevel+1][0]*(tilesize-1)+i*(tilesize-1);
	 int y = (leveloffset-displayoffsety)*tilesize+ey*tilesize+1-startingpoint[curlevel+1][1]*(tilesize-1)+j*(tilesize-1);
	 rectfill(bg,x,y,x+tilesize-2,y+tilesize-2,colorkey[level[curlevel+1][j][i]]);        
	 }
	 
     }*/
	
	for (int i=0;i<levelsize;i++)
		for (int j=0;j<levelsize;j++)
			if (level[curlevel][j][i]==S)
			{
				px=i;
				py=j;
			}	
	
	mode = 0;		
}

bool canmove(int x, int y)
{
	//	return ((level[curlevel][y][x]==2)||(level[curlevel][y][x]==8)||(level[curlevel][y][x]==11)||(level[curlevel][y][x]==14)||(level[curlevel][y][x]==15)||(level[curlevel][y][x]==16));
	if ((x>=0)&&(y>=0)&&(x<levelsize)&&(y<levelsize)) 
	{

		if (mode==1)//squish bottom to top
		{
			for (int j=0;j<levelsize;j++)
			{
				if (level[curlevel][j][x]>=S)
					return true;
				else if (level[curlevel][j][x]==W)
					break;
			}
		}	
		else if (mode==2)//squish top to bottom
		{
			for (int j=levelsize-1;j>=0;j--)
			{
				if (level[curlevel][j][x]>=S)
					return true;
				else if (level[curlevel][j][x]==W)
					break;
			}
		}
		else if (mode==3)//squish left to right
		{
			for (int i=0;i<levelsize;i++)
			{
				if (level[curlevel][y][i]>=S)
					return true;
				else if (level[curlevel][y][i]==W)
					break;
			}
		}
		else if (mode==4)//squish right to left
		{
			for (int i=levelsize-1;i>=0;i--)
			{
				if (level[curlevel][y][i]>=S)
					return true;
				else if (level[curlevel][y][i]==W)
					break;
			}
		}		
		//otherwise return true
		return false;
	}
	else return false;
}
/*
 bool canshoot(int x, int y)
 {
 return ((level[curlevel][y][x]==2)||(level[curlevel][y][x]==8)||(level[curlevel][y][x]==9)||(level[curlevel][y][x]==14)||(level[curlevel][y][x]==15)||(level[curlevel][y][x]==16));   
 }*/

volatile unsigned int frames, fps;
void second_counter(void)
{
	fps=frames;
	frames=0;
} END_OF_FUNCTION(second_counter);
int timewaster_delay;
extern void do_prog(void);

volatile unsigned int ticks;
void ticker(void)
{
	++ticks;
} END_OF_FUNCTION(ticker);


int main() {
    
	
	init();
	
	
	
	int shotcolor[2];
	shotcolor[0]=6;
	shotcolor[1]=7;
    
	while (!key[KEY_ESC]) 
	{
		//reset level
		/*          if (key[KEY_Q])
		 {
		 initlevel();
		 }          */
		
		if (canpress<presstimer)
			canpress++;
		
		{
			
			if ((canpress==presstimer)&&key[KEY_R])
			{
				canpress=0;
				initlevel();	
			}
			
			//clear screen contents
			for (int i=0;i<levelsize;i++)
				for (int j=0;j<levelsize;j++)
					display[i][j]=0;
			//momentum stuff
			
			if	(canpress==presstimer)
			{
			if (mode==1)//squish top to bottom
			{
				if (key[KEY_RIGHT])
				{
					if  (canmove(px+1,py))
						px++; 
				}
				if (key[KEY_LEFT])
				{
					if (canmove(px-1,py))               
						px--; 
				}

				if (key[KEY_UP]||key[KEY_DOWN])
				{
					mode=0;
					play_sample(sound[S_SHOOT], 255, pan, pitch, FALSE);	
					canpress=0;
					
					for (int j=0;j<levelsize;j++)
						if (level[curlevel][j][px]==L || level[curlevel][j][px]==S )
						{
							py=j;
							break;
						}
					
				}
			}			
			else if (mode==2)//squish bottom to top
				{
					if (key[KEY_RIGHT])
					{
						if  (canmove(px+1,py))
							px++; 
					}
					if (key[KEY_LEFT])
					{
						if (canmove(px-1,py))               
							px--; 
					}
					
					if (key[KEY_UP]||key[KEY_DOWN])
					{
						mode=0;
						play_sample(sound[S_SHOOT], 255, pan, pitch, FALSE);	
						canpress=0;
						
						for (int j=levelsize-1;j>=0;j--)
							if (level[curlevel][j][px]==L || level[curlevel][j][px]==S )
							{
								py=j;
								break;
							}
						
					}
				}	
			else if (mode==3)//left to right
			{
				if (key[KEY_DOWN])
				{
					if (canmove(px,py+1))
					{
						py++; 
					}
				}					
				//temp move up control to test stuff
				if (key[KEY_UP])
				{
					if  (canmove(px,py-1))
						py--; 
				}
				
				
				if (key[KEY_LEFT] || key[KEY_RIGHT])
				{
					mode=0;
					play_sample(sound[S_SHOOT], 255, pan, pitch, FALSE);	
					canpress=0;
					
					for (int i=0;i<levelsize;i++)
						if (level[curlevel][py][i]==L || level[curlevel][py][i]==S )
						{
							px=i;
							break;
						}				
				}
				
				
			}
			else if (mode==4)//squish right to left
			{
				if (key[KEY_DOWN])
				{
					if (canmove(px,py+1))
					{
						py++; 
					}
				}					
				//temp move up control to test stuff
				if (key[KEY_UP])
				{
					if  (canmove(px,py-1))
						py--; 
				}
				
				
				if (key[KEY_LEFT] || key[KEY_RIGHT])
				{
					mode=0;
					play_sample(sound[S_SHOOT], 255, pan, pitch, FALSE);	
					canpress=0;
					
					for (int i=levelsize-1;i>=0;i--)
						if (level[curlevel][py][i]==L || level[curlevel][py][i]==S )
						{
							px=i;
							break;
						}				
				}
				
				
			}
			else if (mode==0)
			{
				if (key[KEY_UP])//squish top to bottom					
				{
					bool intersects=false;
					for (int j=0;j<py;j++)
						if (level[curlevel][j][px]==W)
							intersects=true;
					if (!intersects)
					{
						mode=1;
						play_sample(sound[S_SHOOT], 255, pan, pitch, FALSE);	
						canpress=0;
					}
					else
						play_sample(sound[S_FAIL], 255, pan, pitch, FALSE);	

				}			
				else if (key[KEY_DOWN])//squish bottom to top					
				{
					bool intersects=false;
					for (int j=levelsize-1;j>py;j--)
						if (level[curlevel][j][px]==W)
							intersects=true;
					if (!intersects)
					{
						mode=2;
						play_sample(sound[S_SHOOT], 255, pan, pitch, FALSE);	
						canpress=0;
					}
					else
						play_sample(sound[S_FAIL], 255, pan, pitch, FALSE);	
				}			
				else if (key[KEY_LEFT])//squish left to right					
				{
					bool intersects=false;
					for (int i=0;i<px;i++)
						if (level[curlevel][py][i]==W)
							intersects=true;
					if (!intersects)
					{
						mode=3;
						play_sample(sound[S_SHOOT], 255, pan, pitch, FALSE);	
						canpress=0;
					}
					else
						play_sample(sound[S_FAIL], 255, pan, pitch, FALSE);	
				}	
				else if (key[KEY_RIGHT])//squish right to left					
				{
					bool intersects=false;
					for (int i=levelsize-1;i>px;i--)
						if (level[curlevel][py][i]==W)
							intersects=true;
					if (!intersects)
					{
						mode=4;
						play_sample(sound[S_SHOOT], 255, pan, pitch, FALSE);	
						canpress=0;
					}
					else
						play_sample(sound[S_FAIL], 255, pan, pitch, FALSE);	
				}					
			}
			}
			else
				if (!(key[KEY_UP]||key[KEY_DOWN]||key[KEY_LEFT]||key[KEY_RIGHT]||key[KEY_SPACE]||key[KEY_R]))
					canpress=0;
			
			
			
			
		}
		
		//check for end of level
		if (mode==1)//top to bottom
		{
			bool endintersect=false;
			
			for (int j=0;j<levelsize;j++)
				if (level[curlevel][j][px]==F)
					endintersect=true;
				else if (level[curlevel][j][px]==W)
					break;			
			if (endintersect)
			{
				curlevel++;
				canpress=0;
				initlevel();
				play_sample(sound[S_FINISH], 255, pan, pitch, FALSE);				
			}
		}			
		else if (mode==2)//bottom to top
		{
			bool endintersect=false;
			
			for (int j=levelsize-1;j>=0;j--)
				if (level[curlevel][j][px]==F)
					endintersect=true;
				else if (level[curlevel][j][px]==W)
					break;			
			if (endintersect)
			{
				curlevel++;
				canpress=0;
				initlevel();
				play_sample(sound[S_FINISH], 255, pan, pitch, FALSE);				
			}
		}
		else if (mode==3)//left to right
		{
			bool endintersect=false;

			for (int i=0;i<levelsize;i++)
				if (level[curlevel][py][i]==F)
					endintersect=true;
				else if (level[curlevel][py][i]==W)
					break;			
			if (endintersect)
			{
				curlevel++;
				canpress=0;
				initlevel();
				play_sample(sound[S_FINISH], 255, pan, pitch, FALSE);				
			}
		}
		else if (mode==4)//left to right
		{
			bool endintersect=false;
			
			for (int i=levelsize-1;i>=0;i--)
				if (level[curlevel][py][i]==F)
					endintersect=true;
				else if (level[curlevel][py][i]==W)
					break;			
			if (endintersect)
			{
				curlevel++;
				canpress=0;
				initlevel();
				play_sample(sound[S_FINISH], 255, pan, pitch, FALSE);				
			}
		}	
		
		//draw basic level     
		if (mode==0)
		{
			for (int i=0;i<levelsize;i++)
				for (int j=0;j<levelsize;j++)
				{
					if (level[curlevel][j][i]==F)
						display[i][j]=F;
					else if (level[curlevel][j][i]==L||level[curlevel][j][i]==S)
						display[i][j]=L;
					else if (level[curlevel][j][i]==W)
						display[i][j]=W;
					else
						display[i][j]=B;
				}
		}
		else if (mode==1) //top to bottom
		{
			for (int i=0;i<levelsize;i++)
			{	
				int candidate=B;
				//first check form the player up
				for (int j=0;j<levelsize;j++)
					if (level[curlevel][j][i]==W)
					{
						if (candidate==B)
							candidate=W;
						break;
					}
					else if (candidate!=F)
					{
						if (level[curlevel][j][i]==F)
						{
							candidate=F;
							break;
						}
						else if (level[curlevel][j][i]==L||level[curlevel][j][i]==S)
						{
							candidate=L;
						}
					}
				
				display[i][py]=candidate;		
			}
		}	
		else if (mode==2) //top to bottom
		{
			for (int i=0;i<levelsize;i++)
			{	
				int candidate=B;
				//first check form the player up
				for (int j=levelsize-1;j>=0;j--)
					if (level[curlevel][j][i]==W)
					{
						if (candidate==B)
							candidate=W;
						break;
					}
					else if (candidate!=F)
					{
						if (level[curlevel][j][i]==F)
						{
							candidate=F;
							break;
						}
						else if (level[curlevel][j][i]==L||level[curlevel][j][i]==S)
						{
							candidate=L;
						}
					}
				
				display[i][py]=candidate;		
			}
		}	
		else if (mode==3) //left to right
		{
			for (int j=0;j<levelsize;j++)
			{	
				int candidate=B;
				//first check form the player left
				for (int i=0;i<levelsize;i++)
					if (level[curlevel][j][i]==W)
					{
						if (candidate==B)
							candidate=W;
						break;
					}
					else if (candidate!=F)
					{
						if (level[curlevel][j][i]==F)
						{
							candidate=F;
							break;
						}
						else if (level[curlevel][j][i]==L||level[curlevel][j][i]==S)
						{
							candidate=L;
						}
					}
						
				display[px][j]=candidate;							
			}
		}
		else if (mode==4) //right to left
		{
			for (int j=0;j<levelsize;j++)
			{	
				int candidate=B;
				//first check form the player left
				for (int i=levelsize-1;i>=0;i--)
					if (level[curlevel][j][i]==W)
					{
						if (candidate==B)
							candidate=W;
						break;
					}
					else if (candidate!=F)
					{
						if (level[curlevel][j][i]==F)
						{
							candidate=F;
							break;
						}
						else if (level[curlevel][j][i]==L||level[curlevel][j][i]==S)
						{
							candidate=L;
						}
					}
				
				display[px][j]=candidate;							
			}
		}		
		
		//draw player
		display[px][py]=pcol;
		
		//draw screen contents;
		//          blit(bg,buffer, 0,0,0,0,800,600);
		clear_to_color(buffer,makecol(50,50,50));    
		for (int i=0;i<levelsize;i++)
			for (int j=0;j<levelsize;j++)
				rectfill(buffer,(i)*tilesize+100,(j)*tilesize,(i)*tilesize+tilesize-1+100,(j)*tilesize+tilesize-1,colorkey[display[i][j]]);
		
		
		/* control timing */
		while (ticks<1)
		{
			rest(0);
		}
		ticks=0;
		++frames;
		
		blit(buffer,screen, 0,0,0,0,800,600);
		
	}	
	
	
	
	deinit();
	return 0;
}
END_OF_MAIN()

void init() {
	int depth, res;
	allegro_init();
	depth = desktop_color_depth();
	if (depth == 0) depth = 32;
	set_color_depth(depth);
	res = set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 800, 600, 0, 0);
	if (res != 0) {
		allegro_message(allegro_error);
		exit(-1);
	}
	
	install_timer();
	install_keyboard();
	install_mouse();
	
	if (install_sound(DIGI_AUTODETECT, MIDI_NONE, NULL) != 0) {
		allegro_message("Error initialising sound system\n%s\n", allegro_error);
	}
	
	
	sound[0] = load_wav("finish.wav");                       
	sound[1] = load_wav("shoot.wav");            
	sound[2] = load_wav("fail.wav");            
	
	LOCK_FUNCTION(second_counter);
	LOCK_VARIABLE(fps);
	LOCK_VARIABLE(frames);
	LOCK_FUNCTION(ticker);
	LOCK_VARIABLE(ticks);
	
	
	frames=timewaster_delay=0;
	install_int_ex(second_counter, BPS_TO_TIMER(1));
	install_int_ex(ticker, BPS_TO_TIMER(10));
	
	
	int white=makecol(255,255,255);
	int offwhite=makecol(255,255,192);  
	int black=makecol(0,0,0);
	int blue=makecol(0,0,255);
	int pink=makecol(210,150,150);
	int aqua=makecol(200,200,255);
	int green=makecol(0,255,0);
	int purple=makecol(255,0,255);
	int grey=makecol(50,50,50);
	int yellow=makecol(255,255,0);
	int brown=makecol(93,40,11);
	int lightblue=makecol(100,100,255);
	int lighterblue=makecol(200,170,255);
	int red=makecol(255,40,40);
	
	colorkey[0]=lighterblue; //empty space
	colorkey[1]=lightblue; //empty space in world
	colorkey[2]=pink;//wall
	colorkey[3]=green; //impenetrable wall
	colorkey[4]=green; //island
	colorkey[5]=yellow; //finish point
	colorkey[6]=red;//player
	buffer=create_bitmap(800,600);
	//        bg=create_bitmap(800,600);        
	curlevel=10;
	canpress=presstimer;
	
	initlevel();
}

void deinit() {
	clear_keybuf();
	/* add other deinitializations here */
}
